<template>
  <wrapper
    fill
    margin
    padding
    background
  >
    <schema-table
      ref="table"
      :schema="schema"
      @row-click="onToggle"
    />
    <schedule-dialog ref="scheduleDialog" />
  </wrapper>
</template>

<script>
import { getPublishHistory } from '@/api/platform'
import {
  State,
  EventPriority,
  EventTarget,
  PublishType
} from '@/constant'
import { getEventDescription } from '@/utils/event'

export default {
  name: 'ScheduleDeployHistory',
  data () {
    return {
      schema: {
        condition: { status: State.RESOLVED },
        list: getPublishHistory,
        transform: this.transform,
        cols: [
          { type: 'expand', render (data, h) {
            return h('div', {
              staticClass: 'o-info'
            }, [
              h('div', null, data.desc),
              h('div', null, `设备：${data.device}`)
            ])
          } },
          { prop: 'type', label: '类型', width: 100 },
          { prop: 'name', label: '名称', 'min-width': 100 },
          { prop: 'createBy', label: '申请人' },
          { prop: 'createTime', label: '发布时间' },
          { type: 'invoke', render: [
            { label: '查看', on: this.onView }
          ] }
        ]
      }
    }
  },
  methods: {
    transform (item) {
      const same = this.getSame(item)
      const diff = this.getDiff(item)
      return { ...same, ...diff }
    },
    getSame ({ programCalendarName, resolutionRatio, createBy, createByUsername, createTime, calendarReleaseDeviceList }) {
      return {
        name: programCalendarName,
        resolutionRatio,
        createBy: createByUsername || createBy,
        createTime,
        device: calendarReleaseDeviceList?.map(item => item.deviceName).join('，')
      }
    },
    getDiff (item) {
      const target = JSON.parse(item.target)
      let type = ''
      switch (target.type) {
        case PublishType.CALENDAR:
          type = '排期'
          break
        case PublishType.EVENT:
          type = ['', '默认播放', '单播', '插播'][target.detail.priority]
          break
        default:
          break
      }
      return {
        type,
        target,
        desc: this.getDesc(target)
      }
    },
    getDesc (target) {
      if (target.type === PublishType.EVENT && target.detail.priority === EventPriority.INSERTED) {
        return getEventDescription(target.detail)
      }
      return ''
    },
    onToggle (row) {
      this.$refs.table.getInst().toggleRowExpansion(row)
    },
    onView ({ target: { type, detail } }) {
      switch (type) {
        case PublishType.CALENDAR:
          this.viewSchedule(detail)
          break
        case PublishType.EVENT:
          if (detail.target.type === EventTarget.RECUR) {
            this.viewSchedule(detail.target.id)
          } else {
            this.viewProgram(detail.target.id)
          }
          break
        default:
          break
      }
    },
    viewSchedule (id) {
      this.$refs.scheduleDialog.show(id)
    },
    viewProgram (id) {
      window.open(this.$router.resolve({
        name: 'program',
        params: { id }
      }).href, '_blank')
    }
  }
}
</script>
